.trivy-scanner:
  parallel:
    matrix:
      - SCANNER: [trivy]
        DOCKERFILE_SOURCE: [Dockerfile, Dockerfile.fips:fips]

.integration_test:
  extends:
    - .not-on-schedule
    - .scanners-matrix
  image: $CS_IMAGE
  retry: 1
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - vendor/ruby
  stage: test
  variables:
    IMAGE_TAG: $CS_IMAGE
    CS_QUIET: "true"
  artifacts:
    when: always
    reports:
      junit: rspec.xml
  script:
    - sudo ./script/setup_integration
    - bundle config set path 'vendor/ruby'
    - bundle install --quiet
    - bundle exec rake $SPEC_NAME

.generic_integration_test:
  extends: .integration_test
  variables:
    SPEC_NAME: spec_integration_generic

alpine:
  variables:
    INTEGRATION_TEST_IMAGE: alpine:3.12.0
  extends: .generic_integration_test

centos:
  variables:
    INTEGRATION_TEST_IMAGE: centos:8
  extends: .generic_integration_test

debian:
  variables:
    INTEGRATION_TEST_IMAGE: debian:buster-20210511
  extends: .generic_integration_test

distroless:
  variables:
    INTEGRATION_TEST_IMAGE: gcr.io/distroless/base-debian9:latest
  extends: .generic_integration_test

ubuntu:
  variables:
    INTEGRATION_TEST_IMAGE: ubuntu:bionic-20210222
  extends: .generic_integration_test

ubi:
  variables:
    INTEGRATION_TEST_IMAGE: redhat/ubi8:8.2-299
  extends: .generic_integration_test

rhel:
  variables:
    INTEGRATION_TEST_IMAGE: registry.access.redhat.com/rhel7:7.9-333
  extends: .generic_integration_test

rockylinux:
  variables:
    INTEGRATION_TEST_IMAGE: rockylinux:8.5
  extends: .generic_integration_test

amazonlinux:
  variables:
    INTEGRATION_TEST_IMAGE: amazonlinux:2.0.20201218.1
  extends: .generic_integration_test

photon:
  variables:
    INTEGRATION_TEST_IMAGE: photon:1.0-20210409
  extends:
    - .generic_integration_test
    - .trivy-scanner

opensuseleap:
  variables:
    INTEGRATION_TEST_IMAGE: opensuse/leap:15.0
  extends:
    - .generic_integration_test
    - .trivy-scanner

oraclelinux:
  variables:
    INTEGRATION_TEST_IMAGE: oraclelinux:8.2
  extends: .generic_integration_test

almalinux:
  variables:
    INTEGRATION_TEST_IMAGE: almalinux:8.4
  extends: .generic_integration_test

webgoat:
  variables:
    INTEGRATION_TEST_IMAGE:
      "registry.gitlab.com/gitlab-org/security-products/dast/webgoat-8.0\
      @sha256:bc09fe2e0721dfaeee79364115aeedf2174cce0947b9ae5fe7c33312ee019a4e"
  extends: .generic_integration_test

ca cert:
  variables:
    SPEC_NAME: spec_integration_ca_cert
  extends: .integration_test

trivy java db:
  variables:
    SPEC_NAME: spec_integration_trivy_java_db
  extends:
    - .integration_test
    - .trivy-scanner